#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Chase"
#define MYWNDCLASS		"CLASS_DX9_Chase"
#define WIDTH			640 			// ʂ̉̃TCY
#define HEIGHT			480 			// ʂ̏c̃TCY
#define PI				(float)3.1415926535897932
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define G_SIZE			2.0f			// nʂ̑傫

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXMESH				g_pMeshTea = NULL;			// eB[|bg
LPD3DXMESH				g_pMeshGrd = NULL;			// n
float					g_pos_x[2] = {-0.3f,1.5f};	// eB[|bgXW
float					g_pos_z[2] = {0.0f,1.5f};	// eB[|bgZW
float					g_roll[2]  = {0,90};		// eB[|bg̉]px (x)

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	SetupMatrices();
void	Set_Light();
void	Set_Material(float red,float green,float blue);
void	Draw_Ground();
void	Draw_Teapot();
void	Draw_Teapot1();
void	Draw_Main();
void	Get_Key();
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED( InitD3D(hWnd) )){
			MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		SetTimer(hWnd,1,100,NULL);
		break;
		
	case WM_TIMER:
		Get_Key();					// L[͂̎擾
		Draw_Main();				// `
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
			case VK_ESCAPE: 		// [ESC] L[ƏI
				SendMessage(hWnd, WM_CLOSE, 0, 0);
				break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);
		DestroyWindow(hWnd);
		Cleanup();					// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(!RegisterClassEx(&wc))
		return 0;
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(!hWnd)
		return 0;
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	// D3D9Device 쐬
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
			return E_FAIL;
		}
	}
	
	// eB[|bg̍쐬
	D3DXCreateTeapot(g_pD3DDev, &g_pMeshTea, NULL);
	// nʂ̍쐬
	D3DXCreatePolygon(g_pD3DDev, G_SIZE*2, 4, &g_pMeshGrd, NULL);
	// ݒ̏
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ̏
void InitGeometry()
{
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE,  TRUE);
	g_pD3DDev->SetFVF(D3DFVF_XYZ);
	
	Set_Light();		// Cg̐ݒ
	SetupMatrices();	// ϊs̐ݒ
}// InitGeometry

// ϊs̐ݒ
void SetupMatrices()
{
	// J̈ʒu
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0.0f,2.0f,2.5f),&D3DXVECTOR3(0.0f,0.0f,1.0f),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// E̍LƃAXyNgƋ
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,60.0f * PI / 180.0f,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
}// SetupMatrices

// Ɩ̐ݒ
void Set_Light()
{
	D3DXVECTOR3 vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory(&light, sizeof(D3DLIGHT9));
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	vecDir = D3DXVECTOR3(-1.0f,-1.0f,1.0f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00808080);
}// Set_Light

// }eA̐ݒ
void Set_Material(float red,float green,float blue)
{
	D3DMATERIAL9 mtrl;
	
	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
	mtrl.Diffuse.r = mtrl.Ambient.r = red;
	mtrl.Diffuse.g = mtrl.Ambient.g = green;
	mtrl.Diffuse.b = mtrl.Ambient.b = blue;
	// }eAKp
	g_pD3DDev->SetMaterial( &mtrl );
}// Set_Material

// nʂ̕`
void Draw_Ground()
{
	D3DXMATRIX matW,matRX,matRY,matT;
	D3DXMatrixRotationX(&matRX,-90.0f/180*PI);
	D3DXMatrixRotationY(&matRY,45.0f/180*PI);
	D3DXMatrixTranslation(&matT,0,0,0);
	matW = matRX * matRY * matT;
	g_pD3DDev->SetTransform(D3DTS_WORLD,&matW);
	g_pMeshGrd->DrawSubset(0);
}// Draw_Ground

// eB[|bg̕`
// idx:(0:F, 1:F)
void Draw_Teapot(int idx)
{
	// ]ƈʒuƃTCY
	D3DXMATRIX matW,matS,matRY,matT;
	D3DXMatrixScaling(&matS, 0.2f, 0.2f, 0.2f);
	D3DXMatrixRotationY(&matRY,(g_roll[idx]-90.0f)/180*PI);
	D3DXMatrixTranslation(&matT,g_pos_x[idx],0.17f,g_pos_z[idx]);
	matW = matS * matRY * matT;
	g_pD3DDev->SetTransform(D3DTS_WORLD,&matW);
	g_pMeshTea->DrawSubset(0);
}// Draw_Teapot

// eB[|bgiFj̕`
void Draw_Teapot1()
{
	// FFւ̊px
	float roll = (float)atan2(g_pos_x[0] - g_pos_x[1],g_pos_z[0] - g_pos_z[1]) * 180 / PI;
	if(roll < 0)
		roll += 360;
	else if(roll >= 360)
		roll -= 360;

	// 덷 }POx͈͓̔ŁAFFɌĂƂAOi
	if(fabs(roll - g_roll[1]) < 10){
		g_pos_x[1] += 0.02f * (float)sin(g_roll[1]/180*PI);
		g_pos_z[1] += 0.02f * (float)cos(g_roll[1]/180*PI);

		if(g_pos_x[1] < -G_SIZE || g_pos_x[1] > G_SIZE)
			g_pos_x[1] -= 0.02f * (float)sin(g_roll[1]/180*PI);

		if(g_pos_z[1] < -G_SIZE || g_pos_z[1] > G_SIZE)
			g_pos_z[1] -= 0.02f * (float)cos(g_roll[1]/180*PI);
	}
	else{
		float fDif = roll - g_roll[1];
		if((fDif >= 0 && fDif < 180) || fDif < -180){
			g_roll[1] += 5;
			if(g_roll[1] >= 360)
				g_roll[1] -= 360;
		}
		else{
			g_roll[1] -= 5;
			if(g_roll[1] < 0)
				g_roll[1] += 360;
		}
	}
	Draw_Teapot(1);
}// Draw_Teapot1

// `
void Draw_Main()
{	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if( SUCCEEDED( g_pD3DDev->BeginScene() ) )
	{
		// nʂ̕`
		Set_Material(0.7f,0.7f,0.7f);
		Draw_Ground();
		// eB[|bgiFj̕`
		Set_Material(0,0,1);
		Draw_Teapot(0);
		// eB[|bgiFj̕`
		Set_Material(1,1,0);
		Draw_Teapot1();
		
		g_pD3DDev->EndScene();
//		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		g_roll[0] -= 10;
		if(g_roll[0] == 0)
			g_roll[0] = 360;
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		g_roll[0] += 10;
		if(g_roll[0] == 360)
			g_roll[0] = 0;
	}
	
	if(GetAsyncKeyState(VK_UP) & 0x8000){			// []L[ꂽƂ
		g_pos_x[0] += 0.04f * (float)sin(g_roll[0]/180*PI);
		g_pos_z[0] += 0.04f * (float)cos(g_roll[0]/180*PI);
		
		if(g_pos_x[0] < -G_SIZE || g_pos_x[0] > G_SIZE)
			g_pos_x[0] -= 0.04f * (float)sin(g_roll[0]/180*PI);
		if(g_pos_z[0] < -G_SIZE || g_pos_z[0] > G_SIZE)
			g_pos_z[0] -= 0.04f * (float)cos(g_roll[0]/180*PI);
	}
	else if(GetAsyncKeyState(VK_DOWN) & 0x8000){	// []L[ꂽƂ
		g_pos_x[0] -= 0.04f * (float)sin(g_roll[0]/180*PI);
		g_pos_z[0] -= 0.04f * (float)cos(g_roll[0]/180*PI);
		
		if(g_pos_x[0] < -G_SIZE || g_pos_x[0] > G_SIZE)
			g_pos_x[0] += 0.04f * (float)sin(g_roll[0]/180*PI);
		if(g_pos_z[0] < -G_SIZE || g_pos_z[0] > G_SIZE)
			g_pos_z[0] += 0.04f * (float)cos(g_roll[0]/180*PI);
	}
}// Get_Key

// IuWFNg̉
void Cleanup()
{
	RELEASE(g_pMeshTea);
	RELEASE(g_pMeshGrd);
	RELEASE(g_pD3DDev);
	RELEASE(g_pD3D);
}// Cleanup
